﻿/*---------------------------------------------------*/
function print (input, level)
/*---------------------------------------------------*/
{
    if(!level) level = 0;    
    var indent = Array(level+1).join("    ");
    
    if (typeof input == "object") {
        for (var key in input) {
            if (input.hasOwnProperty (key)) { // exclude prototypes
                var value = input[key];
                if (typeof value == "object" && value !== null) {
                    $.write( indent + key );
                     if (key == "parent" || key == "window") { // prevent infinite loop
                        $.write(" : [object " + value.type + "]\n");
                     } else {
                         $.write(" ▾ \n");
                         print (value, level+1); // recurse
                     }
                } else {
                    $.writeln( indent + key + " : " + value );
                }
            }
		}
	} else {
		$.writeln( input );
	}
}

/*--------------------------------------------------------------*/ 
function getDataFromSpreadsheet(theFile)
/*--------------------------------------------------------------*/ 
{
	var c = 0;
	while (!theFile.eof) // keep looping until the end of the file
	{	
		var textline = theFile.readln();  // read text line
		var DataLine = textline.split(","); // splits text line into array, separated by the commas
		if (DataLine[0] != "byte") {
			D[c] = {
				"num"  : DataLine[0],
				"hex"  : DataLine[1],
				"dec"  : DataLine[2],
				"id"   : DataLine[3],
				"pPos" : DataLine[4],
				"Byte" : DataLine[5],
				"bPos" : DataLine[6],
				"size" : DataLine[7],
				"desc" : DataLine[8]
				}
			c++;
		}
	}
	theFile.close(); // close the file
}

/*--------------------------------------------------------------*/
function removeRowsWithEmptyIDs()
/*--------------------------------------------------------------*/
{
	var i = 0;
	while (i < D.length) {
		if (D[i].id === "") {
			D.splice(i, 1);
		} else {
			++i;
		}
	}
}

/*--------------------------------------------------------------*/ 
function getSortingOrder()
/*--------------------------------------------------------------*/ 
{
	var rowIDs = [];
	for (i=0; i<D.length; i++){
		var row = D[i];
		rowIDs.push(row.id);
	}
	rowIDs.sort(function(a, b){return a - b});
	return rowIDs;
}

/*---------------------------------------------*/

var D = new Array();
var S = '"rules": [\r';

var theFile = File.openDialog("Select CSV spreadsheet", "");
var fileName = theFile.name.replace(/\.[^.]+$/, "");

if (theFile != null)
{	
	theFile.open("r","",""); // open the file
	getDataFromSpreadsheet(theFile);
	removeRowsWithEmptyIDs();
	var rowIDs = getSortingOrder();
	
	for (i=0; i<rowIDs.length; i++){
		var idToFind = rowIDs[i];
		var seekingID = true;
		var j = 0;
		while (seekingID) {
			var row = D[j];
			if (row.id == idToFind) {
				seekingID = false;
				S += '\t{\r';
				S += '\t\t"bPos": ' + row.bPos + ',\r'; 
				S += '\t\t"byte": ' + row.Byte + ',\r'; 
				S += '\t\t"id": ' + row.id + ',\r';
				S += '\t\t"msg": "sysex",\r';
				S += '\t\t"pPos": ' + row.pPos + ',\r';
				S += '\t\t"size": ' + row.size + '\r';
				S += '\t},\r';
			} else {
				j++;
			}
		}
	}

	S = S.substring(0, S.length - 2);
	S += '\r]';

	var outputFile = new File(theFile.path+"/"+fileName+".json");
	outputFile.encoding = "UTF-8";
	outputFile.open("w");
	outputFile.write(S);
	outputFile.close();	

}

